package com.ruoyi.zhushi.util;

import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Date;

public class TimeUtils {

    public static String getStartTime() {
        LocalDate today = LocalDate.now();
        // 定义一天的开始和结束时间
        LocalTime startTime = LocalTime.of(0, 0, 0); // 00:00:00
        LocalDateTime startOfDay = today.atTime(startTime);
        // 格式化输出
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        String startOfDayStr = startOfDay.format(formatter);
        return startOfDayStr;
    }

    public static String  getEndTime() {
        LocalDate today = LocalDate.now();
        // 定义一天的开始和结束时间
        LocalTime endTime = LocalTime.of(23, 59, 59); // 23:59:59
        LocalDateTime endOfDay = today.atTime(endTime);
        // 格式化输出
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        String endOfDayStr  = endOfDay.format(formatter);
        return endOfDayStr ;
    }

    // 获取当月开始时间
    public static Date getMonthStart() {
        LocalDateTime startOfMonth = LocalDateTime.now()
            .withDayOfMonth(1)
            .with(LocalTime.MIN);

        return Date.from(startOfMonth.atZone(ZoneId.systemDefault()).toInstant());
    }

    // 获取当月结束时间
    public static Date getMonthEnd() {
        LocalDateTime endOfMonth = LocalDateTime.now()
            .plusMonths(1)
            .withDayOfMonth(1)
            .with(LocalTime.MIN)
            .minusSeconds(1);

        return Date.from(endOfMonth.atZone(ZoneId.systemDefault()).toInstant());
    }

    // 格式化日期
    private static String formatDate(Date date, DateTimeFormatter formatter) {
        LocalDateTime localDateTime = date.toInstant()
            .atZone(ZoneId.systemDefault())
            .toLocalDateTime();

        return localDateTime.format(formatter);
    }

    public static String getFirstDayOfMonth() {
        Date monthStart = getMonthStart();
        // 格式化输出
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        return formatDate(monthStart, formatter);
    }

    public static String getLastDayOfMonth() {
        Date monthEnd = getMonthEnd();
        // 格式化输出
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        return formatDate(monthEnd, formatter);
    }
}
